package com.ibm.jp.sample;
import java.io.*;
import javax.xml.bind.JAXB;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.DatatypeConverter;
import com.ibm.jtc.jax.tools.xjc.runtime.*;
import com.ibm.jtc.jax.xml.bind.marshaller.CharacterEscapeHandler;

public class CompleteCharacterEscapeHandler implements CharacterEscapeHandler {
 
  public CompleteCharacterEscapeHandler() {
    super();
  }
 
/**
 * @param ch The array of characters.
 * @param start The starting position.
 * @param length The number of characters to use.
 * @param isAttVal true if this is an attribute value literal.
*/
  public void escape(char[] ch, int start, int length, boolean isAttVal, Writer out) throws IOException {
    int limit = start + length;
    for (int i = start; i < limit; i++) {
      char c = ch[i];
      if (c == '&' || c == '<' || c == '>' || c == '\"' || c == '\'') {
        if (i != start) {
          out.write(ch, start, i - start);
        }
        start = i + 1;
        switch (ch[i]) {
          case '&':
            out.write("&amp;");
            break;
 
          case '<':
            out.write("&lt;");
            break;
 
          case '>':
            out.write("&gt;");
            break;

          case '\"':
            out.write("&quot;");
            break;
 
          case '\'':
            out.write("&apos;");
            break;
        }
      }
    }
    if (start != limit) {
      out.write(ch, start, limit - start);
    }
  }
}
